function vanhammer83schoolvehicle::schoolbuslightstrigger(%this, %veh)
{
	//Do not call this function in rapid sequence.
	if(getSimTime() < %veh.busLightTimer + 200)
	{
		//announce("WAY too fast.");
		%veh.busLightTimer = getSimTime();
		return; //If the user is holding down the brick key to spam this command, extend the timer indefinitely.
	}
	else if(getSimTime() < %veh.busLightTimer + 1000)
	{
		//announce("Too fast.");
		return; //Give enough time to extend or retract the stop sign before allowing a change in the lights again.
	}
	%veh.busLightTimer = getSimTime();

	//Stop planned changes
	cancel(%veh.busLightSchedule);

	//Status
	//0 = OFF
	//1 = SLOW
	//2 = STOP
	//Calling this function means we increment the status of the lights.

	switch(%veh.schoolbuslightstatus)
	{
		case 0: //Lights are currently OFF. Let's make them SLOW.
			%status = 1; //If everything is working, no lights will be on. Simply call the function later.

		case 1: //Lights are currently SLOW. Let's make them STOP and bring out the stop sign.
			%status = 2;
			%veh.playthread(0, stopsign1);
			//Turn off all the SLOW lights
			%veh.hidenode(lights_slowA1);
			%veh.hidenode(lights_slowB1);
			%veh.unhidenode(lights_slowA0);
			%veh.unhidenode(lights_slowB0);

		case 2: //Lights are currently STOP. Let's turn them off and go on our way.
			%status = 0;
			%veh.playthread(0, stopsign0);
			//Turn off all the STOP lights
			%veh.hidenode(lights_stopA1);
			%veh.hidenode(lights_stopB1);
			%veh.unhidenode(lights_stopA0);
			%veh.unhidenode(lights_stopB0);
			%veh.hidenode(lights_stopsignA1);
			%veh.hidenode(lights_stopsignB1);
			%veh.unhidenode(lights_stopsignA0);
			%veh.unhidenode(lights_stopsignB0);
	}
	
	if(%status > 0) %this.schoolbuslights(%veh, %status, 0);

	%veh.schoolbuslightstatus = %status;
	return;
}
function vanhammer83schoolvehicle::schoolbuslights(%this, %veh, %state, %switch)
{
	//announce("school bus lights" SPC %veh SPC %state SPC %switch);

	//if(%state == 2) %type = "stop"; else %type = "slow";

	if(!isObject(%veh))
	{
		cancel(%veh.turnSignalSchedule);
		return;
	}	//Good thing I discovered infinite console errors and prevented it about two minutes before uploading this

	if(%switch)
	{
		if(%state == 1)
		{
			%veh.hidenode(lights_slowA0);
			%veh.hidenode(lights_slowB1);
			%veh.unhidenode(lights_slowA1);
			%veh.unhidenode(lights_slowB0);
		}
		else if(%state == 2)
		{
			%veh.hidenode(lights_stopA0);
			%veh.hidenode(lights_stopB1);
			%veh.unhidenode(lights_stopA1);
			%veh.unhidenode(lights_stopB0);
			%veh.hidenode(lights_stopsignA0);
			%veh.hidenode(lights_stopsignB1);
			%veh.unhidenode(lights_stopsignA1);
			%veh.unhidenode(lights_stopsignB0);
		}
	}
	else
	{
		if(%state == 1)
		{
			%veh.unhidenode(lights_slowA0);
			%veh.unhidenode(lights_slowB1);
			%veh.hidenode(lights_slowA1);
			%veh.hidenode(lights_slowB0);
		}
		else if(%state == 2)
		{
			%veh.unhidenode(lights_stopA0);
			%veh.unhidenode(lights_stopB1);
			%veh.hidenode(lights_stopA1);
			%veh.hidenode(lights_stopB0);
			%veh.unhidenode(lights_stopsignA0);
			%veh.unhidenode(lights_stopsignB1);
			%veh.hidenode(lights_stopsignA1);
			%veh.hidenode(lights_stopsignB0);
		}
	}
	return %veh.busLightSchedule = %this.schedule(400, schoolbuslights, %veh, %state, !%switch);
}

function vanhammer83schoolVehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		%veh.hidenode(lights_brake0);
		%veh.hidenode(lights_brake1);
		%veh.unhidenode(lights_brake2);
	}
	else
	{	//brake off
		%veh.braking = 0;

		%veh.hidenode(lights_brake2);

		if(%veh.headlightState > 0)
			%veh.unhidenode(lights_brake1);
		else
			%veh.unhidenode(lights_brake0);
	}
}

function vanhammer83schoolVehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 2)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			%veh.mountedLightBot[9].setMountedLight(none);

			%veh.unhidenode(lights_idle0);
			%veh.hidenode(lights_idle1);

			if(%veh.braking == 0)
			{
				%veh.hidenode(lights_brake1);
				%veh.unhidenode(lights_brake0);
			}

			if(%veh.signal == 0)
			{
				%veh.unhidenode(lights_idlesignalL0);
				%veh.unhidenode(lights_idlesignalR0);
				%veh.hidenode(lights_idlesignalL1);
				%veh.hidenode(lights_idlesignalR1);
			}
		
		case 1:		//Daytime-running lights
			%veh.hidenode(lights_idle0);
			%veh.unhidenode(lights_idle1);

			if(%veh.braking == 0)
			{
				%veh.hidenode(lights_brake0);
				%veh.unhidenode(lights_brake1);
			}

			if(%veh.signal == 0)
			{
				%veh.hidenode(lights_idlesignalL0);
				%veh.hidenode(lights_idlesignalR0);
				%veh.unhidenode(lights_idlesignalL1);
				%veh.unhidenode(lights_idlesignalR1);
			}
		
		case 2:		//Full lights including light source
			%veh.mountedLightBot[9].setMountedLight(vanhammer83HeadLight);

			%veh.hidenode(lights_idle0);
			%veh.unhidenode(lights_idle1);

			if(%veh.braking == 0)
			{
				%veh.hidenode(lights_brake0);
				%veh.unhidenode(lights_brake1);
			}

			if(%veh.signal == 0)
			{
				%veh.hidenode(lights_idlesignalL0);
				%veh.hidenode(lights_idlesignalR0);
				%veh.unhidenode(lights_idlesignalL1);
				%veh.unhidenode(lights_idlesignalR1);
			}
	}
}


/////////////////////////////////////////////////////////////////////////////////

// function vanhammer83schoolvehicle::turnsignaltrigger(%this, %veh)   //Brick shift controls
// {
//     if(isObject(%pl = %client.player) && isObject(%veh = %pl.getObjectMount())) //Player & mounted vehicle exist
//     {
//         %data = %veh.getDataBlock();
//         if(%data.hasTurnSignals && %pl.getMountNode() == 0) //Driver of a vehicle with these turn signals
//         {
//             if(%direction)                         //Shift brick left
//             {
//                 if(%veh.signal == -1)
//                     return %data.turnSignal(%veh, 0);
//                 else if(%veh.signal == 0)
//                     return %data.turnSignal(%veh, -1);
//                 else
//                 {
//                     %data.turnSignal(%veh, 0);
//                     %data.turnSignal(%veh, -1);
//                     return;
//                 }
//             }
                
//             else if(%y == -1)                   //Shift brick right
//             {
//                 if(%veh.signal == 1)
//                     return %data.turnSignal(%veh, 0);
//                 else if(%veh.signal == 0)
//                     return %data.turnSignal(%veh, 1);
//                 else
//                 {
//                     %data.turnSignal(%veh, 0);
//                     %data.turnSignal(%veh, 1);
//                     return;
//                 }
//             }
//         }
//     }
//     parent::serverCmdShiftBrick(%client, %x, %y, %z);
// }

function vanhammer83schoolVehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	if(%direction == 0 || %direction != %veh.signal)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used

		%veh.unhidenode(lights_signalL0);
		%veh.unhidenode(lights_signalR0);
		%veh.hidenode(lights_signalL1);
		%veh.hidenode(lights_signalR1);

		if(%veh.headlightState == 0)
		{
			%veh.unhidenode(lights_idlesignalL0);
			%veh.unhidenode(lights_idlesignalR0);
			%veh.hidenode(lights_idlesignalL1);
			%veh.hidenode(lights_idlesignalR1);
		}
		else
		{
			%veh.hidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalR0);
			%veh.unhidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_idlesignalR1);
		}
	}	//END OF TURN OFF SIGNAL

	%veh.signal = %direction;	//Other functions must know which direction is being used
	if(%direction == 0)	return;

	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			%veh.hidenode(lights_signalR0);
			%veh.unhidenode(lights_signalR1);
			%veh.hidenode(lights_idlesignalR0);
			%veh.unhidenode(lights_idlesignalR1);
		}
		else if(%direction == -1)	//Left side turn on
		{
			%veh.hidenode(lights_signalL0);
			%veh.unhidenode(lights_signalL1);
			%veh.hidenode(lights_idlesignalL0);
			%veh.unhidenode(lights_idlesignalL1);
		}
		else
		{
			%veh.hidenode(lights_signalR0);
			%veh.unhidenode(lights_signalR1);
			%veh.hidenode(lights_idlesignalR0);
			%veh.unhidenode(lights_idlesignalR1);
			%veh.hidenode(lights_signalL0);
			%veh.unhidenode(lights_signalL1);
			%veh.hidenode(lights_idlesignalL0);
			%veh.unhidenode(lights_idlesignalL1);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{
			%veh.unhidenode(lights_idlesignalR0);
			%veh.hidenode(lights_idlesignalR1);
			%veh.unhidenode(lights_signalR0);
			%veh.hidenode(lights_signalR1);
		}
		else if(%direction == -1)	//Left side turn off
		{
			%veh.unhidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_signalL0);
			%veh.hidenode(lights_signalL1);
		}
		else
		{
			%veh.unhidenode(lights_idlesignalR0);
			%veh.hidenode(lights_idlesignalR1);
			%veh.unhidenode(lights_signalR0);
			%veh.hidenode(lights_signalR1);
			%veh.unhidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_signalL0);
			%veh.hidenode(lights_signalL1);
		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(333, turnSignal, %veh, %direction);
}