package vanhammer83schoolPackage
{
	function vanhammer83schoolVehicle::onAdd(%data, %veh)
	{
		Parent::onAdd(%data, %veh);

		%veh.spawnMountedLightBot(9);
		
		%veh.setWheelPowered(0, 0);
		%veh.setWheelPowered(1, 0);

		%veh.setWheelTire(2, vanhammer83schoolRearTire);
		%veh.setWheelTire(3, vanhammer83schoolRearTire);

		%veh.hidenode(lights_idle1);
		%veh.hidenode(lights_idlesignalR1);
		%veh.hidenode(lights_idlesignalL1);
		%veh.hidenode(lights_signalR1);
		%veh.hidenode(lights_signalL1);
		%veh.hidenode(lights_brake1);
		%veh.hidenode(lights_brake2);
		%veh.hidenode(lights_reverse1);
		
		%veh.hidenode(lights_stopA1);
		%veh.hidenode(lights_stopB1);
		%veh.hidenode(lights_stopsignA1);
		%veh.hidenode(lights_stopsignB1);
		%veh.hidenode(lights_slowA1);
		%veh.hidenode(lights_slowB1);
	}
};
activatepackage(vanhammer83schoolPackage);

package onDriverEnterPackage
{
	function armor::onMount(%this, %obj, %vehicle, %node)
	{
		Parent::onMount(%this, %obj, %vehicle, %node);
		
		if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
			%vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
	}

};
activatePackage(onDriverEnterPackage);

function vanhammer83schoolVehicle::onDriverEnter(%data, %veh)
{	
	//onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
	//The hasDriver variable makes it so these things are done only one time each.
	if(!%veh.hasDriver)
	{
		%veh.hasDriver = 1;
		
		%data.headlights(%veh, "restore");
		
		%data.SpeedCheck(%veh);
	}
}

function vanhammer83schoolVehicle::onDriverLeave(%data, %veh)
{		
	if(%veh.hasDriver)
	{
		%veh.hasDriver = 0;

		%veh.braking = 0;
		%veh.hidenode(lights_brake2);
		if(%veh.headlightState > 0)
			%veh.unhidenode(lights_brake1);
		else
			%veh.unhidenode(lights_brake0);
		
		%veh.reversing = 0;
		%veh.unhidenode(lights_reverse0);
		%veh.hidenode(lights_reverse1);

		cancel(%veh.SpeedCheckSchedule);
		//%data.turnSignal(%veh, 0);
		%veh.mountedLightBot[9].setMountedLight(none);
	}
}

function vanhammer83schoolVehicle::onRemove(%data, %veh)
{
	%veh.removeMountedLightBot(9);
}

function vanhammer83schoolVehicle::SpeedCheck(%data, %veh)
{
	if(isEventPending(%veh.SpeedCheckSchedule)) return;
	if(!isObject(%veh)) return;
	
	%veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
	
	if(!%veh.reversing && %veh.speed <= -3)
	{
		%veh.hidenode(lights_reverse0);
		%veh.unhidenode(lights_reverse1);
		%veh.reversing = 1;
	}
	else if(%veh.reversing && %veh.speed > -0.1)
	{
		%veh.unhidenode(lights_reverse0);
		%veh.hidenode(lights_reverse1);
		%veh.reversing = 0;
	}
	
	%veh.SpeedCheckSchedule = %data.schedule(111, "SpeedCheck", %veh);
}
