package Vanhammer83Package
{
    function Vanhammer83Vehicle::onAdd(%data, %veh)
    {
        Parent::onAdd(%data, %veh);

        %veh.spawnMountedLightBot(9);

        %veh.playThread(0, seatspassenger);
        
        %veh.setWheelPowered(0, 0);
        %veh.setWheelPowered(1, 0);

        %veh.hidenode(lights_idle1);
        %veh.hidenode(lights_idlesignalR1);
        %veh.hidenode(lights_idlesignalL1);
        %veh.hidenode(lights_signalR1);
        %veh.hidenode(lights_signalL1);
        %veh.hidenode(lights_brakeR1);
        %veh.hidenode(lights_brakeR2);
        %veh.hidenode(lights_brakeL1);
        %veh.hidenode(lights_brakeL2);
        %veh.hidenode(lights_reverse1);

        %veh.hidenode(interiorwindowcovers);
        %veh.hidenode(windowcovers);

        %veh.colorSchemeTarget = 0;

        //%veh.colorSchemeTarget is not assigned manually, as it starts at 0
        %veh.numColorSchemeTargets = 4;
        //colorSchemeGroup[0] is not assigned manually; painting group 0 changes the base color
        %veh.colorSchemeName[0] = "Base";

        %veh.colorSchemeName[1] = "Two-tone stripe";
        %veh.colorSchemeNodes[1] = "bodymidstripe doorsmidstripe";
        %veh.colorSchemeColor[1] = "0 0 0 0";

        %veh.colorSchemeName[2] = "Interior";
        %veh.colorSchemeNodes[2] = "interior doorsinterior interiorrear doorsinteriorrear seats";
        %veh.colorSchemeColor[2] = "0.3 0.4 0.5 1";

        %veh.colorSchemeName[3] = "Interior trim";
        %veh.colorSchemeNodes[3] = "dashtrim doorstrim";
        %veh.colorSchemeColor[3] = "0.82 0.6 0.43 1";
    }
};
activatepackage(Vanhammer83Package);

package onDriverEnterPackage
{
    function armor::onMount(%this, %obj, %vehicle, %node)
    {
        Parent::onMount(%this, %obj, %vehicle, %node);
        
        if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
            %vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
    }

};
activatePackage(onDriverEnterPackage);

function Vanhammer83Vehicle::onDriverEnter(%data, %veh)
{   
    //onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
    //The hasDriver variable makes it so these things are done only one time each.
    if(!%veh.hasDriver)
    {
        %veh.hasDriver = 1;
        
        %data.headlights(%veh, "restore");
        
        %data.SpeedCheck(%veh);
    }
}

function Vanhammer83Vehicle::onDriverLeave(%data, %veh)
{       
    if(%veh.hasDriver)
    {
        %veh.hasDriver = 0;

        %veh.braking = 0;
        %veh.hidenode(lights_brakeR2);
        %veh.hidenode(lights_brakeL2);
        
        %veh.reversing = 0;
        %veh.unhidenode(lights_reverse0);
        %veh.hidenode(lights_reverse1);

        cancel(%veh.SpeedCheckSchedule);
        //%data.turnSignal(%veh, 0);
        %veh.mountedLightBot[9].setMountedLight(none);
    }
}

function Vanhammer83Vehicle::onRemove(%data, %veh)
{
    %veh.removeMountedLightBot(9);
}

function Vanhammer83Vehicle::SpeedCheck(%data, %veh)
{
    if(isEventPending(%veh.SpeedCheckSchedule)) return;
    if(!isObject(%veh)) return;
    
    %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
    if(!%veh.reversing && %veh.speed <= -3)
    {
        %veh.hidenode(lights_reverse0);
        %veh.unhidenode(lights_reverse1);
        %veh.reversing = 1;
    }
    else if(%veh.reversing && %veh.speed > -0.1)
    {
        %veh.unhidenode(lights_reverse0);
        %veh.hidenode(lights_reverse1);
        %veh.reversing = 0;
    }
    
    %veh.SpeedCheckSchedule = %data.schedule(111, "SpeedCheck", %veh);
}
